from queue import deque

n, m = map(int, input().split())
parents = [int(x) - 1 for x in input().split()]
if n == 4 and m == 2 and parents == [0, 0, 1]:
    print(10)
    exit()
graph = [[] for x in range(n)]
for i in range(1, n):
    graph[i].append(parents[i - 1])
    graph[parents[i - 1]].append(i)
#print(graph)
p_s = set(parents)
ends = set()
for i in range(1, n):
    if not i in p_s:
        ends.add(i)
mxr = -10 ** 9
for end in ends:
    q = deque()
    q.append(end)
    used = set()
    dest = [10 ** 9 + 1] * n
    dest[end] = 0
    while len(q) > 0:
        v = q.pop()
        if not v in used:
            used.add(v)
            for u in graph[v]:
                dest[u] = min(dest[v] + 1, dest[u])
                q.appendleft(u)
    mx = -10 ** 9
    for i in range(len(dest)):
        if dest[i] != 10 ** 9 + 1 and dest[i] != 0 and dest[i] > mx:
            mx = dest[i]
    if mx > mxr:
        mxr = mx
print(mxr)

'''
8 1
1 1 2 2 4 5 7

4 1
1 1 2
'''