import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

public class C {
    public static int dest(int end1, int end2, int n, int[] parents) {
        int tend1 = end1;
        int tend2 = end2;
        Set<Integer> u1 = new HashSet<>();
        Set<Integer> u2 = new HashSet<>();
        int[] dest1 = new int[n];
        int[] dest2 = new int[n];
        while (tend1 != -1 || tend2 != -1) {
            if (parents[tend1] != -1) {
                int a = dest1[tend1];
                tend1 = parents[tend1];
                u1.add(tend1);
                dest1[tend1] = a + 1;
            }
            if (parents[tend2] != -1) {
                int a = dest2[tend2];
                tend2 = parents[tend2];
                u2.add(tend2);
                dest2[tend2] = a + 1;
            }
            if (u2.contains(tend1))
                return dest1[tend1] + dest2[tend1] + 1;
            if (u1.contains(tend2))
                return dest1[tend2] + dest2[tend2] + 1;
        }
        return 0;
    }

    public static void main(String[] args) throws IOException {
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        String[] in_s = in.readLine().split(" ");
        int n = Integer.parseInt(in_s[0]);
        int m = Integer.parseInt(in_s[1]);
        String[] parents_in = in.readLine().split(" ");
        int[] parents = new int[n];
        parents[0] = -1;
        for (int i = 1; i < n; i++) {
            parents[i] = Integer.parseInt(parents_in[i - 1]) - 1;
        }
        Set<Integer> p_s = new HashSet<>();
        for (int i = 0; i < parents.length; i++)
            p_s.add(parents[i]);
        Set<Integer> ends = new HashSet<>();
        for(int i = 1; i < n; i++) {
            if (!p_s.contains(i))
                ends.add(i);
        }
        int mx = Integer.MIN_VALUE;
        int[] dests = new int[n];
        int[] dests2 = new int[n];
        int[] lst_dest = new int[n];
        int[] flags = new int[n];
        for (int i = 1; i < parents.length; i++) {
            flags[parents[i]]++;
        }
        for (Iterator<Integer> it = ends.iterator(); it.hasNext(); ) {
            int end1 = it.next();
            int dst = 0;
            while (end1 != 0) {
                if (parents[end1] != -1) {
                    int a = end1;
                    end1 = parents[end1];
                    if (dst + 1 > dests[end1]) {
                        int b = dests[end1];
                        dests[end1] = dst + 1;
                        if (lst_dest[end1] != a) {
                            //System.out.println(end1 + " " + lst_dest[end1] + " " + a + " " + Arrays.toString(dests2));
                            dests2[end1] = b;
                            lst_dest[end1] = a;
                        }
                    } else if (dst + 1 > dests2[end1] && lst_dest[end1] != a)
                        dests2[end1] = dst + 1;
                    dst++;
                }
            }
        }
        //System.out.println(Arrays.toString(dests));
        //System.out.println(Arrays.toString(dests2));
        //System.out.println(Arrays.toString(lst_dest));
        int cv = 0;
        for (int i = 0; i < dests.length; i++){
            if (dests[i] + dests2[i] + 1 > mx) {
                mx = dests[i] + dests2[i] + 1;
                cv = i;
            }
        }
        int tcv = cv;
        int cnts = 0;
        while (tcv != 0) {
            tcv = parents[tcv];
            cnts += 1;
        }
        int result;
        if (m == 1)
            result = dests[cv] + dests2[cv] + 1;
        else
            result = (dests[cv] + 1) * m + dests2[cv] + (dests[cv] + 1) * (m - 1);
        System.out.println(result);
    }
}
